#include <pew/vector/intrinsic.hpp>
using simd = pew::intrinsic<double>;

int main() {
{
        auto reg1 = simd::set(-2, 20, 5);
        auto reg2 = simd::set(11, 7, 36);
        auto reg3 = simd::dot(reg1, reg2);
        printf("reg1: %s\n", simd::dump(reg1).c_str());
        printf("reg2: %s\n", simd::dump(reg2).c_str());
        printf("reg3: %s\n", simd::dump(reg3).c_str());
    }
    {
        auto reg1 = simd::set(-2, 54, -89);
        auto reg2 = simd::abs(reg1);
        printf("vec1: %s\n", simd::dump(reg2).c_str());
    }
    // {
    //     auto reg1 = simd::set(0);
    //     auto reg2 = simd::set(1, 0, 0);
    //     auto reg3 = simd::set(0.000001);
    //     printf("Reg1 ~~ 0: %i\n", simd::zero(reg1));
    //     printf("Reg2 ~~ 0: %i\n", simd::zero(reg2));
    //     printf("Reg3 ~~ 0: %i\n", simd::zero(reg3));
    // }
    // {
    //     auto reg1 = simd::set(2);
    //     auto reg2 = simd::set(2.000001);
    //     auto reg3 = simd::set(1);
    //     printf("Reg1 == Reg1: %i\n", simd::equal(reg1, reg1));
    //     printf("Reg1 ~~ Reg1: %i\n", simd::equal(reg1, reg1));
    //     printf("Reg1 == Reg2: %i\n", simd::equal(reg1, reg2));
    //     printf("Reg1 ~~ Reg2: %i\n", simd::cmp(reg1, reg2));
    //     printf("Reg1 == Reg3: %i\n", simd::equal(reg1, reg3));
    //     printf("Reg1 ~~ Reg3: %i\n", simd::cmp(reg1, reg3));
    // }
    // {
    //     auto reg1 = simd::set(200, 0, 0);
    //     auto reg2 = simd::set(0, 1, 0);
    //     auto reg3 = simd::cross(reg1, reg2);
    //     printf("reg3: %s\n", simd::dump(reg3).c_str());
    // }
    {
        auto reg1 = simd::set(3, 4, 20);
        auto reg2 = simd::len(reg1);
        // auto reg3 = simd::len3(reg1);
        printf("reg2: %s\n", simd::dump(reg2).c_str());
        // printf("reg3: %s\n", simd::dump(reg3).c_str());
    }
    // {
    //     auto reg1 = simd::set(2, 30, 5.6);
    //     auto reg2 = simd::rmax(reg1);
    //     printf("reg2: %s\n", simd::dump(reg2).c_str());
    // }
    // {
    //     auto reg1 = simd::set(2, 30, 5.6);
    //     auto reg2 = simd::set(-2, 13, -3);
    //     auto reg3 = simd::ang(reg1, reg2);
    //     printf("reg3: %s\n", simd::dump(reg3).c_str());
    // }
}